;;;; -*- scheme -*-
;;;; This file is part of guile-sql.
;;;; Copyright (C) 2002, 2008 Sergey Poznyakoff
;;;; 
;;;; This program is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;; 
;;;; This program is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with this program; if not, write to the Free Software Foundation,
;;;; Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

changequote([,])dnl

(define-module (gamma sql)
  :export-syntax (sql-catch-failure sql-ignore-failure))
(use-syntax (ice-9 syncase))

(let ((lib-path "LIBDIR/"))
  (load-extension (string-append
		   lib-path "libguile-sql-v-VERSION") "sql_init"))

include(BUILDDIR/gsql_lib.inc)
include(BUILDDIR/gsql_conn.inc)

(define-syntax sql-catch-failure
  (syntax-rules ()
    ((sql-catch-failure (handler) expr)
     (catch 'gsql-error
	    (lambda () expr)
	    (lambda (key err descr)
	      (handler err descr))))
    ((sql-catch-failure expr)
     (sql-catch-failure (sql-error-handler) expr))))
			

(define-syntax sql-ignore-failure
  (syntax-rules ()
    ((sql-ignore-failure (value) expr)
     (catch 'gsql-error
	    (lambda () expr)
	    (lambda (key err descr)
	      value)))
    ((sql-ignore-failure expr)
     (sql-ignore-failure (#f) expr))))

;;;; End of sql.scm
